﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.3
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub


'Sub SetNinePatchDrawable(Control As View, ImageName As String)
'   Dim r As Reflector
'   Dim package As String
'   Dim id As Int
'   package = r.GetStaticField("anywheresoftware.b4a.BA", "packageName")
'   id = r.GetStaticField(package & ".R$drawable", ImageName)
'   r.Target = r.GetContext
'   r.Target = r.RunMethod("getResources")
'   Control.Background = r.RunMethod2("getDrawable", id, "java.lang.int")
'End Sub

'Add a border to a view. Adds Fillcolor, StrokeColor(Border color), rx,ry (rounded corners) SWidth(Border width)
'and padding which is only applied to Labels
Sub SetBorderDrawable (V As View, FillColor As Int, StrokeColor As Int, rx As Float, ry As Float, SWidth As Float, Padding As Int)

	Dim BM As Bitmap
	Dim BMD As BitmapDrawable
	Dim Cnv As Canvas
	'We need to draw on the bitmap with a canvas
	BM.InitializeMutable(V.Width,V.Height)
	Cnv.Initialize2(BM)
	'Sizing Variables need to be cast to floats to enable the constructor to be found.
	Dim l,t,r,b As Float
	l = 0
	t = 0
	r = V.Width
	b = V.Height
	'Needs a RectF object not just a Rect
	Dim rect1 As JavaObject
	rect1.InitializeNewInstance("android.graphics.RectF",Array As Object(l,t,r,b))
	'Create a Paint.Style object
	Dim PS As JavaObject
	PS.InitializeStatic("android.graphics.Paint.Style")
	'Create and setup a Paint object
	Dim Paint,Paint1 As JavaObject
	Paint.InitializeNewInstance("android.graphics.Paint",Null)
	Paint.RunMethod("setStrokeWidth",Array As Object(SWidth))
	Paint.RunMethod("setColor",Array As Object(StrokeColor))
	Paint.RunMethod("setStyle",Array As Object(PS.GetField("STROKE")))
	Paint.RunMethod("setAntiAlias",Array As Object(True))
	
	Paint1.InitializeNewInstance("android.graphics.Paint",Null)
	Paint1.RunMethod("setColor",Array As Object(FillColor))
	Paint1.RunMethod("setAntiAlias",Array As Object(True))
	Paint1.RunMethod("setStyle",Array As Object(PS.GetField("FILL")))
	
	'Get the canvas object from the wrapper
	Dim CnvJO As JavaObject = Cnv
	CnvJO = CnvJO.GetField("canvas")
	'Draw the filled round rect on the bitmap using the canvas
	CnvJO.RunMethod("drawRoundRect",Array As Object(rect1,rx,ry,Paint1))
	'Draw the border round rect on the bitmap using the canvas
	CnvJO.RunMethod("drawRoundRect",Array As Object(rect1,rx,ry,Paint))
	'Cast the Bitmap to a BitmapDrawable
	BMD.Initialize(BM)
	If Padding <> -1 And GetType(V) = "android.widget.TextView" Then
		Dim VJO As JavaObject = V
		VJO.RunMethod("setPadding",Array As Object(Padding,Padding,Padding,Padding))
	End If
	'Add it to the view
	V.Background = BMD
End Sub
'Change the size and color of a Checkbox graphic. Set the tick character and color, as well as the box size and color 
'and padding (distance from the box to the edge of the graphic) and a disabled fill color
'Pass "Fill" as the TickChar to fill the box with TickColor when selected.

Sub SetCBDrawable(CB As CheckBox,BoxColor As Int,BoxWidth As Int,TickColor As Int,TickChar As String,DisabledColor As Int,Size As Int,Padding As Int)
	Dim SLD As StateListDrawable
	SLD.Initialize
	
	Dim BMEnabled,BMChecked,BMDisabled As Bitmap
	BMEnabled.InitializeMutable(Size,Size)
	BMChecked.InitializeMutable(Size,Size)
	BMDisabled.InitializeMutable(Size,Size)
	'Draw Enabled State
	Dim CNV As Canvas
	CNV.Initialize2(BMEnabled)
	Dim Rect1 As Rect
	Rect1.Initialize(Padding ,Padding ,Size - Padding ,Size - Padding)
	CNV.DrawRect(Rect1,BoxColor,False,BoxWidth)
	Dim Enabled,Checked,Disabled As BitmapDrawable
	Enabled.Initialize(BMEnabled)
	'Draw Selected state
	Dim CNV1 As Canvas
	CNV1.Initialize2(BMChecked)
	If TickChar = "Fill" Then 
		CNV1.DrawRect(Rect1,TickColor,True,BoxWidth)
		CNV1.DrawRect(Rect1,BoxColor,False,BoxWidth)
	Else
		CNV1.DrawRect(Rect1,BoxColor,False,BoxWidth)
		'Start small and find the largest font that allows the tick to fit in the box
		Dim FontSize As Int = 6
		Do While CNV.MeasureStringHeight(TickChar,Typeface.DEFAULT,FontSize) < Size - (BoxWidth * 2) - (Padding * 2)
			FontSize = FontSize + 1
		Loop
		FontSize = FontSize - 1
		'Draw the TickChar centered in the box
		CNV1.DrawText(TickChar,Size/2,(Size + CNV.MeasureStringHeight(TickChar,Typeface.DEFAULT,FontSize))/2,Typeface.DEFAULT,FontSize,TickColor,"CENTER")
	End If
	Checked.Initialize(BMChecked)
	'Draw disabled State
	Dim CNV2 As Canvas
	CNV2.Initialize2(BMDisabled)
	CNV2.DrawRect(Rect1,DisabledColor,True,BoxWidth)
	CNV2.DrawRect(Rect1,BoxColor,False,BoxWidth)
	Disabled.Initialize(BMDisabled)
	
	'Add to the StateList Drawable
	SLD.AddState(SLD.State_Disabled,Disabled)
	SLD.AddState(SLD.State_Checked,Checked)
	SLD.AddState(SLD.State_Enabled,Enabled)
	SLD.AddCatchAllState(Enabled)
	'Add SLD to the Checkbox
	Dim JO As JavaObject = CB
	JO.RunMethod("setButtonDrawable",Array As Object(SLD))
End Sub

'Change the size and color of a RadioButton graphic.
'Pass the required colors for the attributes, size should be at most the smallest side of the view.
Sub SetRadioButtonDrawable(RBtn As RadioButton,CircleColor As Int,Size As Int,SelectedColor As Int,DisabledColor As Int,StrokeWidth As Int)
    Dim Enabled,Selected,Disabled,DisabledSelected As BitmapDrawable
    Dim EnabledJO,SelectedJO,DisabledJO,DisabledSelectedJO As JavaObject
    Dim SLD As StateListDrawable
    SLD.Initialize

    'Changing the padding also determines how far away the text is from the drawing
    Dim Padding As Int = Size / 100 * 50
    Dim Radius As Int = (Size - Padding) / 2
    Dim InnerPadding As Int = Max(1Dip,1)

    Dim BMEnabled,BMSelected,BMDisabled,BMDisabledSelected As Bitmap
    BMEnabled.InitializeMutable(Size,Size)
    BMSelected.InitializeMutable(Size,Size)
    BMDisabled.InitializeMutable(Size,Size)
    BMDisabledSelected.InitializeMutable(Size,Size)

    'Draw Enabled State
    Dim CNV As Canvas
    CNV.Initialize2(BMEnabled)
    CNV.DrawCircle(Radius + InnerPadding,Size / 2,Radius,CircleColor,False,StrokeWidth)
    Enabled.Initialize(BMEnabled)
    EnabledJO = Enabled
    EnabledJO.RunMethod("setAntiAlias",Array As Object(True))
    Enabled.Gravity = Gravity.left

    'Draw Selected state
    Dim CNV1 As Canvas
    CNV1.Initialize2(BMSelected)
    CNV1.DrawCircle(Radius + InnerPadding,Size / 2,Radius,CircleColor,False,StrokeWidth)
    'Draw the Selected state centered in the box
    CNV1.DrawCircle(Radius + InnerPadding,Size / 2,(Radius - InnerPadding) / 2,SelectedColor,True,StrokeWidth)
    Selected.Initialize(BMSelected)
    SelectedJO = Selected
    SelectedJO.RunMethod("setAntiAlias",Array As Object(True))
    Selected.Gravity = Gravity.left

    'Draw Disabled Selected State
    Dim CNV2 As Canvas
    CNV2.Initialize2(BMDisabledSelected)
    CNV2.DrawCircle(Radius + InnerPadding,Size / 2,Radius,DisabledColor,False,StrokeWidth)
    'Draw the Disabled Selected state centered in the box
    CNV2.DrawCircle(Radius + InnerPadding,Size / 2,(Radius - InnerPadding) / 2,DisabledColor,True,StrokeWidth)
    DisabledSelected.Initialize(BMDisabledSelected)
    DisabledSelectedJO = DisabledSelected
    DisabledSelectedJO.RunMethod("setAntiAlias",Array As Object(True))
    DisabledSelected.Gravity = Gravity.left

    'Draw disabled State
    Dim CNV3 As Canvas
    CNV3.Initialize2(BMDisabled)
    CNV3.DrawCircle(Radius + InnerPadding,Size / 2,Radius,DisabledColor,False,StrokeWidth)
    Disabled.Initialize(BMDisabled)
    DisabledJO = Disabled
    DisabledJO.RunMethod("setAntiAlias",Array As Object(True))
    Disabled.Gravity = Gravity.left

    'Add To the StateList Drawable
    SLD.AddState2(Array As Int(SLD.State_Disabled,SLD.State_Checked),DisabledSelected)
    SLD.AddState(SLD.State_Disabled,Disabled)
    SLD.AddState(SLD.State_Checked,Selected)
    SLD.AddState(SLD.State_Enabled,Enabled)
    SLD.AddCatchAllState(Enabled)
    'Add SLD To the CheckBox
    Dim JO As JavaObject = RBtn
    JO.RunMethod("setButtonDrawable",Array As Object(SLD))
End Sub

'pTipo = 1 embaralha  e pTipo = 0 desembaralha
Sub embaralha ( pTipo As String, pDados As String )
	Dim xLen As Int
	Dim xResp As String
	xLen = pDados.Length
	If pTipo = 1 Then
		Select xLen
		Case 6
			xResp = Chr( Asc(pDados.SubString2(1,2)) + 5 + 14 ) 
			xResp = xResp & Chr( Asc(pDados.SubString2(5,6)) + 5 + 6 )
			xResp = xResp & Chr( Asc(pDados.SubString2(4,5)) + 5 + 10 )
			xResp = xResp & Chr( Asc(pDados.SubString2(0,1)) + 5 + 13 )
			xResp = xResp & Chr( Asc(pDados.SubString2(2,3)) + 5 + 4 )
			xResp = xResp & Chr( Asc(pDados.SubString2(3,4)) + 5 + 7 )
		Case 7
			xResp = Chr( Asc(pDados.SubString2(3,5)) + 5 + 11 )
			xResp = xResp & Chr( Asc(pDados.SubString2(4,5)) + 5 + 13 )
			xResp = xResp & Chr( Asc(pDados.SubString2(0,1)) + 5 + 1 )
			xResp = xResp & Chr( Asc(pDados.SubString2(5,6)) + 5 + 15 )
			xResp = xResp & Chr( Asc(pDados.SubString2(6,7)) + 5 + 16 )
			xResp = xResp & Chr( Asc(pDados.SubString2(1,2)) + 5 + 7 )
			xResp = xResp & Chr( Asc(pDados.SubString2(2,3)) + 5 + 5 )
		Case 8
			xResp = Chr( Asc(pDados.SubString2(2,3)) + 5 + 8 )
			xResp = xResp & Chr( Asc(pDados.SubString2(6,7)) + 5 + 7 )
			xResp = xResp & Chr( Asc(pDados.SubString2(1,2)) + 5 + 15 )
			xResp = xResp & Chr( Asc(pDados.SubString2(5,6)) + 5 + 12 )
			xResp = xResp & Chr( Asc(pDados.SubString2(4,5)) + 5 + 5 )
			xResp = xResp & Chr( Asc(pDados.SubString2(0,1)) + 5 + 16 )
			xResp = xResp & Chr( Asc(pDados.SubString2(7,8)) + 5 + 3 )
			xResp = xResp & Chr( Asc(pDados.SubString2(3,4)) + 5 + 10 )
	
		End Select
	End If
	If pTipo = 0 Then
		Select xLen
		Case 6
			xResp = Chr( Asc(pDados.SubString2(3,4)) - 5 - 13 )
			xResp = xResp & Chr( Asc(pDados.SubString2(0,1)) - 5 - 14 )
			xResp = xResp & Chr( Asc(pDados.SubString2(4,5)) - 5 - 4 )
			xResp = xResp & Chr( Asc(pDados.SubString2(5,6)) - 5 - 7 )
			xResp = xResp & Chr( Asc(pDados.SubString2(2,3)) - 5 - 10 )
			xResp = xResp & Chr( Asc(pDados.SubString2(1,2)) - 5 - 6 )
		Case 7
			xResp = Chr( Asc(pDados.SubString2(2,3)) - 5 - 1 )
			xResp = xResp & Chr( Asc(pDados.SubString2(5,6)) - 5 - 7 )
			xResp = xResp & Chr( Asc(pDados.SubString2(6,7)) - 5 - 5 )
			xResp = xResp & Chr( Asc(pDados.SubString2(0,1)) - 5 - 11 )
			xResp = xResp & Chr( Asc(pDados.SubString2(1,2)) - 5 - 13 )
			xResp = xResp & Chr( Asc(pDados.SubString2(3,4)) - 5 - 15 )
			xResp = xResp & Chr( Asc(pDados.SubString2(4,5)) - 5 - 16 )
		Case 8
			xResp = Chr( Asc(pDados.SubString2(5,6)) - 5 - 16 )
			xResp = xResp & Chr( Asc(pDados.SubString2(2,3)) - 5 - 15 )
			xResp = xResp & Chr( Asc(pDados.SubString2(0,1)) - 5 - 8 )
			xResp = xResp & Chr( Asc(pDados.SubString2(7,8)) - 5 - 10 )
			xResp = xResp & Chr( Asc(pDados.SubString2(4,5)) - 5 - 5 )
			xResp = xResp & Chr( Asc(pDados.SubString2(3,4)) - 5 - 12 )
			xResp = xResp & Chr( Asc(pDados.SubString2(1,2)) - 5 - 7 )
			xResp = xResp & Chr( Asc(pDados.SubString2(6,7)) - 5 - 3 )
		
		End Select
	End If
	
	Return xResp


End Sub

Sub Cripto ( pTipo As String, pQtd As String, pTexto As String) As String
	Dim xOff As Int
	Dim xTemp, xResp  As String	
	Dim xBytes() As Byte
	Dim bConv As ByteConverter
	Dim Sf As StringFunctions
	Sf.Initialize
	
	Select pQtd
		Case "25"
			If pTipo = 1 Then 
				xTemp = bConv.HexFromBytes ( pTexto.GetBytes("UTF8") )
				xTemp = Sf.Pad ( xTemp," ",50,True)
			Else
				xTemp = pTexto	
			End If
			xOff = 0
			xResp =          embaralha(pTipo,xTemp.SubString2(xOff, xOff+8) ) 
			xOff = xOff + 8
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+8) ) 
			xOff = xOff + 8
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+8) ) 
			xOff = xOff + 8

			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+7) ) 
			xOff = xOff + 7
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+7) ) 
			xOff = xOff + 7

			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+6) ) 
			xOff = xOff + 6
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+6) ) 

			If pTipo = 0 Then
				xBytes = bConv.HexToBytes ( xResp)
				xResp  = bConv.StringFromBytes (xBytes, "ASCII")
				xResp = xResp.Trim
#if log
				Log ( "Volta: " & xResp )
#end if				
			End If
			
			
			
		Case "90"
			xTemp = Sf.Pad ( xTemp," ",90,True)
			xOff = 0
			xResp =  embaralha(pTipo,xTemp.SubString2(xOff, xOff+8) ) 
			xOff = xOff + 8
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+8) ) 
			xOff = xOff + 8
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+8) ) 
			xOff = xOff + 8
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+8) ) 
			xOff = xOff + 8
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+8) ) 
			xOff = xOff + 8
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+8) ) 
			xOff = xOff + 8
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+8) ) 
			xOff = xOff + 8
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+8) ) 
			xOff = xOff + 8
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+6) ) 
			xOff = xOff + 6
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+6) ) 
			xOff = xOff + 6
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+6) ) 

	End Select
#if log
Log ( "Embaralha: " & pTipo & " - " & pQtd & " - " & xTemp & " -  " & xResp )	
#end if
	Return xResp
End Sub

Sub CheckConnection As Boolean
    Dim r As Reflector
   
    r.Target = r.GetContext
    r.Target = r.RunMethod2("getSystemService", "connectivity", "java.lang.String")
    r.Target = r.RunMethod("getActiveNetworkInfo")
   
    If r.Target <> Null Then
        Return r.RunMethod("isConnectedOrConnecting")
    End If
   
    Return False
End Sub

Sub KillCall
	'https://www.b4x.com/android/forum/threads/end-call-incoming.19714/
	'Manifest AddPermission("android.permission.CALL_PHONE")
   Dim r As Reflector
   r.Target = r.GetContext
   Dim TelephonyManager, TelephonyInterface As Object
   TelephonyManager = r.RunMethod2("getSystemService", "phone", "java.lang.String")
   r.Target = TelephonyManager
   TelephonyInterface = r.RunMethod("getITelephony")
   r.Target = TelephonyInterface
   r.RunMethod("endCall")
End Sub

Sub getScreenSize As Float
	Dim r As Reflector
	Dim xSize, xHeight, xWidth As Double
	Dim lv As LayoutValues
	
	lv = GetDeviceLayoutValues

   r.Target = r.GetContext
   r.Target = r.RunMethod("getResources")
   r.Target = r.RunMethod("getDisplayMetrics")
   xHeight = r.GetField("ydpi")
   xWidth = r.GetField("xdpi")

	xSize = Sqrt ( Power ( lv.Height / xHeight,2) + Power (lv.Width / xWidth,2) )
	
	Return xSize
End Sub
